VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   7860
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   15840
   LinkTopic       =   "Form1"
   ScaleHeight     =   7860
   ScaleWidth      =   15840
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtInfo 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   7305
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   1
      Top             =   60
      Width           =   15705
   End
   Begin VB.CommandButton cmdListAdapter 
      Caption         =   "List Adapter"
      Height          =   375
      Left            =   13950
      TabIndex        =   0
      Top             =   7440
      Width           =   1845
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 07/2021

Option Explicit

Private Sub cmdListAdapter_Click()

    Dim strTmp As String
    Dim strMAC As String
    Dim strAddr As String
    Dim strDUID As String
    Dim strResult As String
    
    Dim lngItem As Long
    Dim lngCount As Long
    Dim lngBuffSize As Long
    Dim lngAdapterIndex As Long
    
    Dim eFlags As GAA_FLAGS
    Dim eFamily As AF_FAMILY
    
    Dim bytMask() As Byte
    Dim bytBuff() As Byte
    Dim bytIPAdapterAddresses() As Byte
    
    Dim pStr As Long
    Dim pMask As Long
    Dim pAddress As Long
    Dim pIPAdapterAddresses As Long
    
    Dim tSOCKADDR As SOCKADDR
    Dim tSOCKADDR_IN As SOCKADDR_IN
    Dim tSOCKADDR_IN6 As SOCKADDR_IN6
    Dim tIP_ADAPTER_PREFIX As IP_ADAPTER_PREFIX_XP
    Dim tIP_ADAPTER_DNS_SUFFIX As IP_ADAPTER_DNS_SUFFIX
    Dim tIP_ADAPTER_ADDRESSES As IP_ADAPTER_ADDRESSES_LH
    Dim tIP_ADAPTER_GATEWAY_ADDRESS As IP_ADAPTER_GATEWAY_ADDRESS_LH
    Dim tIP_ADAPTER_UNICAST_ADDRESS As IP_ADAPTER_UNICAST_ADDRESS_LH
    Dim tIP_ADAPTER_ANYCAST_ADDRESS As IP_ADAPTER_ANYCAST_ADDRESS_XP
    Dim tIP_ADAPTER_MULTICAST_ADDRESS As IP_ADAPTER_MULTICAST_ADDRESS_XP
    Dim tIP_ADAPTER_DNS_SERVER_ADDRESS As IP_ADAPTER_DNS_SERVER_ADDRESS_XP
    Dim tIP_ADAPTER_WINS_SERVER_ADDRESS As IP_ADAPTER_WINS_SERVER_ADDRESS_LH
    
    txtInfo.Text = vbNullString
    
    eFlags = GAA_FLAG_INCLUDE_ALL_COMPARTMENTS Or GAA_FLAG_INCLUDE_GATEWAYS Or _
             GAA_FLAG_INCLUDE_PREFIX Or GAA_FLAG_INCLUDE_TUNNEL_BINDINGORDER Or _
             GAA_FLAG_INCLUDE_WINS_INFO Or GAA_FLAG_INCLUDE_ALL_INTERFACES
    
    eFamily = AF_UNSPEC

    If GetAdaptersAddresses(eFamily, eFlags, 0&, 0&, lngBuffSize) = ERROR_BUFFER_OVERFLOW Then
        
        ReDim bytIPAdapterAddresses(lngBuffSize - 1)
        
        pIPAdapterAddresses = VarPtr(bytIPAdapterAddresses(0))
        
        If GetAdaptersAddresses(eFamily, eFlags, 0&, pIPAdapterAddresses, lngBuffSize) = ERROR_SUCCESS Then
        
            Do While pIPAdapterAddresses <> 0&
            
                lngAdapterIndex = lngAdapterIndex + 1
            
                strResult = strResult & "****************************** Adapter: " & _
                    Format$(lngAdapterIndex, "00") & " ******************************" & vbNewLine
                
                Call CopyMemory(tIP_ADAPTER_ADDRESSES, ByVal pIPAdapterAddresses, Len(tIP_ADAPTER_ADDRESSES))
            
                strResult = strResult & "AdapterAddresses.IfIndex: " & CStr(tIP_ADAPTER_ADDRESSES.IfIndex) & vbNewLine
                strResult = strResult & "AdapterAddresses.FriendlyName: " & Ptr2String(tIP_ADAPTER_ADDRESSES.FriendlyName) & vbNewLine
                strResult = strResult & "AdapterAddresses.Luid: " & Luid2String(tIP_ADAPTER_ADDRESSES.Luid) & vbNewLine
                strResult = strResult & "AdapterAddresses.Description: " & Ptr2String(tIP_ADAPTER_ADDRESSES.Description) & vbNewLine
                strResult = strResult & "AdapterAddresses.AdapterName: " & StrConv(Ptr2String(tIP_ADAPTER_ADDRESSES.AdapterName), vbUnicode) & vbNewLine
                strResult = strResult & "AdapterAddresses.NetworkGuid: " & Guid2String(tIP_ADAPTER_ADDRESSES.NetworkGuid) & vbNewLine
                strResult = strResult & "AdapterAddresses.TransmitLinkSpeed: " & CStr(CLng(tIP_ADAPTER_ADDRESSES.TransmitLinkSpeed / 100)) & " (Mbps)" & vbNewLine
                strResult = strResult & "AdapterAddresses.ReceiveLinkSpeed: " & CStr(CLng(tIP_ADAPTER_ADDRESSES.ReceiveLinkSpeed / 100)) & " (Mbps)" & vbNewLine
                strResult = strResult & "AdapterAddresses.DnsSuffix: " & Ptr2String(tIP_ADAPTER_ADDRESSES.DnsSuffix) & vbNewLine
                strResult = strResult & "AdapterAddresses.Ipv4Metric: " & CStr(tIP_ADAPTER_ADDRESSES.Ipv4Metric) & vbNewLine
                strResult = strResult & "AdapterAddresses.Ipv6Metric: " & CStr(tIP_ADAPTER_ADDRESSES.Ipv6Metric) & vbNewLine
                strResult = strResult & "AdapterAddresses.CompartmentId: " & CompartmentID2String(tIP_ADAPTER_ADDRESSES.CompartmentID) & vbNewLine
                strResult = strResult & "AdapterAddresses.ConnectionType: " & ConnectionType2String(tIP_ADAPTER_ADDRESSES.ConnectionType) & vbNewLine
                strResult = strResult & "AdapterAddresses.TunnelType: " & TunnelType2String(tIP_ADAPTER_ADDRESSES.TunnelType) & vbNewLine

                
                lngCount = tIP_ADAPTER_ADDRESSES.PhysicalAddressLength - 1
            
                strMAC = vbNullString
            
                For lngItem = 0 To lngCount
                
                    strTmp = Hex$(tIP_ADAPTER_ADDRESSES.PhysicalAddress(lngItem))
                
                    If Len(strTmp) = 1 Then
                        strMAC = strMAC & "0" & strTmp
                    Else
                        strMAC = strMAC & strTmp
                    End If
                
                    If lngItem < lngCount Then
                
                        strMAC = strMAC & "-"
                    
                    End If
            
                Next
            
                strResult = strResult & "AdapterAddresses.PhysicalAddress: " & strMAC & vbNewLine
                
                
                lngCount = tIP_ADAPTER_ADDRESSES.Dhcpv6ClientDuidLength - 1
            
                strDUID = vbNullString
            
                For lngItem = 0 To lngCount
                
                    strTmp = Hex$(tIP_ADAPTER_ADDRESSES.Dhcpv6ClientDuid(lngItem))
                
                    If Len(strTmp) = 1 Then
                        strDUID = strDUID & "0" & strTmp
                    Else
                        strDUID = strDUID & strTmp
                    End If
                
                    If lngItem < lngCount Then
                
                        strDUID = strDUID & "-"
                    
                    End If
            
                Next
            
                strResult = strResult & "AdapterAddresses.Dhcpv6ClientDuid: " & strDUID & vbNewLine
                
                
                strResult = strResult & "AdapterAddresses.Dhcpv6Iaid: " & CStr(tIP_ADAPTER_ADDRESSES.Dhcpv6Iaid) & vbNewLine
                strResult = strResult & "AdapterAddresses.MTU: " & CStr(tIP_ADAPTER_ADDRESSES.Mtu) & vbNewLine
                strResult = strResult & "AdapterAddresses.IfType: " & IfType2String(tIP_ADAPTER_ADDRESSES.IfType) & vbNewLine
                strResult = strResult & "AdapterAddresses.OperStatus: " & OperStatus2String(tIP_ADAPTER_ADDRESSES.OperStatus) & vbNewLine
                strResult = strResult & "AdapterAddresses.Ipv6IfIndex: " & CStr(tIP_ADAPTER_ADDRESSES.Ipv6IfIndex) & vbNewLine
                strResult = strResult & "AdapterAddresses.Flags: " & AdapterAddressesFlags2String(tIP_ADAPTER_ADDRESSES.Flags) & vbNewLine
                
                For lngItem = 0 To UBound(tIP_ADAPTER_ADDRESSES.ZoneIndices)
                
                    strResult = strResult & "AdapterAddresses.ZoneIndices(" & CStr(lngItem + 1) & "): " & _
                        ScopeLevel2String(tIP_ADAPTER_ADDRESSES.ZoneIndices(lngItem)) & vbNewLine
                    
                Next
                
                
                If tIP_ADAPTER_ADDRESSES.FirstUnicastAddress <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstUnicastAddress
                    
                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_UNICAST_ADDRESS, ByVal pAddress, Len(tIP_ADAPTER_UNICAST_ADDRESS))
                    
                        pAddress = tIP_ADAPTER_UNICAST_ADDRESS.Address.lpSockaddr
                        
                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                        
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strAddr = "AdapterUnicast IPv4-Address: " & Ptr2String(pStr)
                                
                                If tIP_ADAPTER_UNICAST_ADDRESS.OnLinkPrefixLength <= 32 Then
                                
                                    strAddr = strAddr & "/" & CStr(tIP_ADAPTER_UNICAST_ADDRESS.OnLinkPrefixLength)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                        
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterUnicast IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                            
                            If tIP_ADAPTER_UNICAST_ADDRESS.OnLinkPrefixLength <= 32 Then
                            
                                If ConvertLengthToIpv4Mask(tIP_ADAPTER_UNICAST_ADDRESS.OnLinkPrefixLength, pMask) = NO_ERROR Then
                            
                                    bytMask = Long2ByteArray(pMask)
                            
                                    strResult = strResult & "AdapterUnicast IPv4-Subnetmask: " & CStr(bytMask(0)) & "." & _
                                                                                                 CStr(bytMask(1)) & "." & _
                                                                                                 CStr(bytMask(2)) & "." & _
                                                                                                 CStr(bytMask(3)) & vbNewLine
                            
                                End If
                                
                            End If
                            
                            If tIP_ADAPTER_UNICAST_ADDRESS.Flags <> 0& Then
                        
                                strResult = strResult & "AdapterUnicast.Flags IPv4: " & AdapterAddressFlags2String(tIP_ADAPTER_UNICAST_ADDRESS.Flags) & vbNewLine
                            
                            End If
                        
                            strResult = strResult & "AdapterUnicast.PrefixOrigin IPv4: " & PrefixOrigin2String(tIP_ADAPTER_UNICAST_ADDRESS.PrefixOrigin) & vbNewLine
                            strResult = strResult & "AdapterUnicast.SuffixOrigin IPv4: " & SuffixOrigin2String(tIP_ADAPTER_UNICAST_ADDRESS.SuffixOrigin) & vbNewLine
                            strResult = strResult & "AdapterUnicast.DadState IPv4: " & DadState2String(tIP_ADAPTER_UNICAST_ADDRESS.DadState) & vbNewLine
                            strResult = strResult & "AdapterUnicast.ValidLifetime IPv4: " & CStr(tIP_ADAPTER_UNICAST_ADDRESS.ValidLifetime) & vbNewLine
                            strResult = strResult & "AdapterUnicast.PreferredLifetime IPv4: " & CStr(tIP_ADAPTER_UNICAST_ADDRESS.PreferredLifetime) & vbNewLine
                            strResult = strResult & "AdapterUnicast.LeaseLifetime IPv4: " & CStr(tIP_ADAPTER_UNICAST_ADDRESS.LeaseLifetime) & vbNewLine
                            
                        Case AF_FAMILY.AF_INET6
                            
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterUnicast IPv6-Address: " & Ptr2String(pStr)
                                
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                If tIP_ADAPTER_UNICAST_ADDRESS.OnLinkPrefixLength <= 128 Then
                                
                                    strAddr = strAddr & "/" & CStr(tIP_ADAPTER_UNICAST_ADDRESS.OnLinkPrefixLength)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine

                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterUnicast IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "AdapterUnicast IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                        
                        
                            If tIP_ADAPTER_UNICAST_ADDRESS.Flags <> 0& Then
                        
                                strResult = strResult & "AdapterUnicast.Flags IPv6: " & AdapterAddressFlags2String(tIP_ADAPTER_UNICAST_ADDRESS.Flags) & vbNewLine
                            
                            End If
                        
                            strResult = strResult & "AdapterUnicast.PrefixOrigin IPv6: " & PrefixOrigin2String(tIP_ADAPTER_UNICAST_ADDRESS.PrefixOrigin) & vbNewLine
                            strResult = strResult & "AdapterUnicast.SuffixOrigin IPv6: " & SuffixOrigin2String(tIP_ADAPTER_UNICAST_ADDRESS.SuffixOrigin) & vbNewLine
                            strResult = strResult & "AdapterUnicast.DadState IPv6: " & DadState2String(tIP_ADAPTER_UNICAST_ADDRESS.DadState) & vbNewLine
                            strResult = strResult & "AdapterUnicast.ValidLifetime IPv6: " & CStr(tIP_ADAPTER_UNICAST_ADDRESS.ValidLifetime) & vbNewLine
                            strResult = strResult & "AdapterUnicast.PreferredLifetime IPv6: " & CStr(tIP_ADAPTER_UNICAST_ADDRESS.PreferredLifetime) & vbNewLine
                            strResult = strResult & "AdapterUnicast.LeaseLifetime IPv6: " & CStr(tIP_ADAPTER_UNICAST_ADDRESS.LeaseLifetime) & vbNewLine
                        
                        End Select
                    
                        pAddress = tIP_ADAPTER_UNICAST_ADDRESS.Next
                        
                    Loop
                
                End If
                
                
                If tIP_ADAPTER_ADDRESSES.FirstAnycastAddress <> 0& Then

                    pAddress = tIP_ADAPTER_ADDRESSES.FirstAnycastAddress

                    Do While pAddress <> 0&

                        Call CopyMemory(tIP_ADAPTER_ANYCAST_ADDRESS, ByVal pAddress, Len(tIP_ADAPTER_ANYCAST_ADDRESS))
                        
                        pAddress = tIP_ADAPTER_ANYCAST_ADDRESS.Address.lpSockaddr

                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))

                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                            
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strResult = strResult & "AdapterAnycast IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterAnycast IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                            
                        Case AF_FAMILY.AF_INET6
                        
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterAnycast IPv6-Address: " & Ptr2String(pStr)
        
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterAnycast IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "AdapterAnycast IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                        
                        End Select

                        If tIP_ADAPTER_ANYCAST_ADDRESS.Flags <> 0& Then
                        
                            strResult = strResult & "AnycastAddress.Flags: " & AdapterAddressFlags2String(tIP_ADAPTER_ANYCAST_ADDRESS.Flags) & vbNewLine
                            
                        End If

                        pAddress = tIP_ADAPTER_ANYCAST_ADDRESS.Next

                    Loop

                End If
                
                
                If tIP_ADAPTER_ADDRESSES.FirstMulticastAddress <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstMulticastAddress

                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_MULTICAST_ADDRESS, ByVal pAddress, Len(tIP_ADAPTER_MULTICAST_ADDRESS))
                    
                        pAddress = tIP_ADAPTER_MULTICAST_ADDRESS.Address.lpSockaddr
                    
                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                            
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strResult = strResult & "AdapterMulticast IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterMulticast IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                        
                        Case AF_FAMILY.AF_INET6
                        
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterMulticast IPv6-Address: " & Ptr2String(pStr)
        
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterMulticast IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "AdapterMulticast IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                            
                        End Select
                    
                        If tIP_ADAPTER_MULTICAST_ADDRESS.Flags <> 0& Then
                        
                            strResult = strResult & "AdapterMulticastAddress.Flags: " & AdapterAddressFlags2String(tIP_ADAPTER_MULTICAST_ADDRESS.Flags) & vbNewLine
                            
                        End If
                    
                        pAddress = tIP_ADAPTER_MULTICAST_ADDRESS.Next
                    
                    Loop
                
                End If
                
                
                If tIP_ADAPTER_ADDRESSES.FirstDnsServerAddress <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstDnsServerAddress
                    
                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_DNS_SERVER_ADDRESS, ByVal pAddress, Len(tIP_ADAPTER_DNS_SERVER_ADDRESS))
                    
                        pAddress = tIP_ADAPTER_DNS_SERVER_ADDRESS.Address.lpSockaddr
                    
                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                            
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strResult = strResult & "AdapterDNS-Server IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterDNS-Server IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                            
                        Case AF_FAMILY.AF_INET6
                        
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterDNS-Server IPv6-Address: " & Ptr2String(pStr)
                                
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterDNS-Server IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "DNS-Server IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                            
                        End Select
                        
                        pAddress = tIP_ADAPTER_DNS_SERVER_ADDRESS.Next
                    
                    Loop
                
                End If
            
                
                If tIP_ADAPTER_ADDRESSES.FirstDnsSuffix <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstDnsSuffix
                    
                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_DNS_SUFFIX, ByVal pAddress, Len(tIP_ADAPTER_DNS_SUFFIX))
                    
                        strResult = strResult & "AdapterDNS-Suffix: " & CStr(tIP_ADAPTER_DNS_SUFFIX.Str) & vbNewLine
                        
                        pAddress = tIP_ADAPTER_DNS_SUFFIX.Next
                    
                    Loop
                
                End If
                
                
                If tIP_ADAPTER_ADDRESSES.FirstPrefix <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstPrefix
                    
                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_PREFIX, ByVal pAddress, Len(tIP_ADAPTER_PREFIX))
                    
                        pAddress = tIP_ADAPTER_PREFIX.Address.lpSockaddr
                    
                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                            
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strAddr = "AdapterPrefix IPv4-Address: " & Ptr2String(pStr)
                                
                                If tIP_ADAPTER_PREFIX.PrefixLength <= 32 Then
                                
                                    strAddr = strAddr & "/" & CStr(tIP_ADAPTER_PREFIX.PrefixLength)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterPrefix IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                        
                        Case AF_FAMILY.AF_INET6
                        
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterPrefix IPv6-Address: " & Ptr2String(pStr)
                                
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                If tIP_ADAPTER_PREFIX.PrefixLength <= 128 Then
                                
                                    strAddr = strAddr & "/" & CStr(tIP_ADAPTER_PREFIX.PrefixLength)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterPrefix IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "AdapterPrefix IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                            
                        End Select
                        
                        pAddress = tIP_ADAPTER_PREFIX.Next
                    
                    Loop
                
                End If
            
            
                If tIP_ADAPTER_ADDRESSES.FirstWinsServerAddress <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstWinsServerAddress
                    
                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_WINS_SERVER_ADDRESS, ByVal pAddress, Len(tIP_ADAPTER_WINS_SERVER_ADDRESS))
                    
                        pAddress = tIP_ADAPTER_WINS_SERVER_ADDRESS.Address.lpSockaddr
                    
                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                            
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strResult = strResult & "AdapterWinsServer IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterWinsServer IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                        
                        Case AF_FAMILY.AF_INET6
                        
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterWinsServer IPv6-Address: " & Ptr2String(pStr)
        
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterWinsServer IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "AdapterWinsServer IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                            
                        End Select
                        
                        pAddress = tIP_ADAPTER_WINS_SERVER_ADDRESS.Next
                    
                    Loop
                
                End If
                
                
                If tIP_ADAPTER_ADDRESSES.FirstGatewayAddress <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.FirstGatewayAddress
                    
                    Do While pAddress <> 0&
                    
                        Call CopyMemory(tIP_ADAPTER_GATEWAY_ADDRESS, ByVal pAddress, Len(tIP_ADAPTER_GATEWAY_ADDRESS))
                    
                        pAddress = tIP_ADAPTER_GATEWAY_ADDRESS.Address.lpSockaddr
                    
                        Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                        Select Case tSOCKADDR.sa_family
                        
                        Case AF_FAMILY.AF_INET
                            
                            Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                            lngBuffSize = INET_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
    
                                strResult = strResult & "AdapterGateway IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN.sin_port <> 0& Then
                                
                                strResult = strResult & "AdapterGateway IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                            End If
                        
                        Case AF_FAMILY.AF_INET6
                        
                            Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                            lngBuffSize = INET6_ADDRSTRLEN
                            ReDim bytBuff(lngBuffSize - 1)
    
                            pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                            If pStr <> 0& Then
        
                                strAddr = "AdapterGateway IPv6-Address: " & Ptr2String(pStr)
        
                                If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                    strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                                End If
                                
                                strResult = strResult & strAddr & vbNewLine
        
                            End If
                            
                            If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                                strResult = strResult & "AdapterGateway IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                            End If
                            
                            If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                                strResult = strResult & "AdapterGateway IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                            End If
                            
                        End Select
                        
                        pAddress = tIP_ADAPTER_GATEWAY_ADDRESS.Next
                    
                    Loop
                
                End If
                
                
                If tIP_ADAPTER_ADDRESSES.Dhcpv4Server.lpSockaddr <> 0& Then
                
                    pAddress = tIP_ADAPTER_ADDRESSES.Dhcpv4Server.lpSockaddr
                
                    Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))
                    
                    Select Case tSOCKADDR.sa_family
                    
                    Case AF_FAMILY.AF_INET
                        
                        Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                        lngBuffSize = INET_ADDRSTRLEN
                        ReDim bytBuff(lngBuffSize - 1)
    
                        pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                        If pStr <> 0& Then
    
                            strResult = strResult & "AdapterDhcpv4Server IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                        End If
                        
                        If tSOCKADDR_IN.sin_port <> 0& Then
                                
                            strResult = strResult & "AdapterDhcpv4Server IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                        End If
                    
                    Case AF_FAMILY.AF_INET6
                    
                        Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                        lngBuffSize = INET6_ADDRSTRLEN
                        ReDim bytBuff(lngBuffSize - 1)
    
                        pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
                                
                        If pStr <> 0& Then
        
                            strAddr = "AdapterDhcpv4Server IPv6-Address: " & Ptr2String(pStr)
        
                            If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                            End If
                                
                            strResult = strResult & strAddr & vbNewLine
        
                        End If
                        
                        If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                            strResult = strResult & "AdapterDhcpv4Server IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                        End If
                        
                        If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                            strResult = strResult & "AdapterDhcpv4Server IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                        End If
                        
                    End Select
                
                End If
                

                If tIP_ADAPTER_ADDRESSES.Dhcpv6Server.lpSockaddr <> 0& Then

                    pAddress = tIP_ADAPTER_ADDRESSES.Dhcpv6Server.lpSockaddr

                    Call CopyMemory(tSOCKADDR, ByVal pAddress, Len(tSOCKADDR))

                    Select Case tSOCKADDR.sa_family
                    
                    Case AF_FAMILY.AF_INET
                        
                        Call CopyMemory(tSOCKADDR_IN, ByVal pAddress, Len(tSOCKADDR_IN))
    
                        lngBuffSize = INET_ADDRSTRLEN
                        ReDim bytBuff(lngBuffSize - 1)
    
                        pStr = InetNtopW(AF_INET, VarPtr(tSOCKADDR_IN.sin_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
    
                        If pStr <> 0& Then
    
                            strResult = strResult & "AdapterDhcpv6Server IPv4-Address: " & Ptr2String(pStr) & vbNewLine
        
                        End If
                        
                        If tSOCKADDR_IN.sin_port <> 0& Then
                                
                            strResult = strResult & "AdapterDhcpv6Server IPv4-Port: " & CStr(tSOCKADDR_IN.sin_port) & vbNewLine
                                
                        End If
                    
                    Case AF_FAMILY.AF_INET6
                        
                        Call CopyMemory(tSOCKADDR_IN6, ByVal pAddress, Len(tSOCKADDR_IN6))
    
                        lngBuffSize = INET6_ADDRSTRLEN
                        ReDim bytBuff(lngBuffSize - 1)
    
                        pStr = InetNtopW(AF_INET6, VarPtr(tSOCKADDR_IN6.sin6_addr.s_b(0)), VarPtr(bytBuff(0)), lngBuffSize)
                                
                        If pStr <> 0& Then
        
                            strAddr = "AdapterDhcpv6Server IPv6-Address: " & Ptr2String(pStr)
        
                            If tSOCKADDR_IN6.sin6_scope_id <> 0& Then
                                
                                strAddr = strAddr & "%" & CStr(tSOCKADDR_IN6.sin6_scope_id)
                                    
                            End If
                                
                            strResult = strResult & strAddr & vbNewLine
        
                        End If
                        
                        If tSOCKADDR_IN6.sin6_port <> 0& Then
                                
                            strResult = strResult & "AdapterDhcpv6Server IPv6-Port: " & CStr(tSOCKADDR_IN6.sin6_port) & vbNewLine
                                
                        End If
                        
                        If tSOCKADDR_IN6.sin6_flowinfo <> 0& Then
                                
                            strResult = strResult & "AdapterDhcpv6Server IPv6-FlowInfo: " & CStr(tSOCKADDR_IN6.sin6_flowinfo) & vbNewLine
                                
                        End If
                        
                    End Select

                End If

                strResult = strResult & "*************************************************************************" & vbNewLine
                strResult = strResult & vbNewLine
            
                pIPAdapterAddresses = tIP_ADAPTER_ADDRESSES.Next
                
            Loop
            
        End If
    
    End If
    
    strResult = CStr(lngAdapterIndex) & " network adapters were found." & vbNewLine & vbNewLine & strResult
    
    Call SetText(txtInfo, strResult)
    
End Sub
