Attribute VB_Name = "modMain"
' Autor: F. Schler (frank@activevb.de)
' Datum: 07/2021

Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const NO_ERROR As Long = &H0&
Public Const ERROR_SUCCESS As Long = &H0&
Public Const NETIO_ERROR_SUCCESS As Long = &H0&
Public Const ERROR_BUFFER_OVERFLOW As Long = &H6F&
Public Const MAX_ADAPTER_ADDRESS_LENGTH  As Long = &H8&
Public Const MAX_DHCPV6_DUID_LENGTH As Long = &H82&
Public Const MAX_DNS_SUFFIX_STRING_LENGTH As Long = &H100&
Public Const NDIS_IF_MAX_STRING_SIZE As Long = &H100&
Public Const INET_ADDRSTRLEN As Long = &H16&
Public Const INET6_ADDRSTRLEN As Long = &H41&
Public Const WM_SETTEXT As Long = &HC&

' ----==== Enums ====----
' IP_ADAPTER_UNICAST_ADDRESS_LH.Flags
' IP_ADAPTER_MULTICAST_ADDRESS_XP.Flags
' IP_ADAPTER_ANYCAST_ADDRESS_XP.Flags
Public Enum IP_ADAPTER_XXX_ADDRESS_XX_FLAGS
    IP_ADAPTER_ADDRESS_DNS_ELIGIBLE = &H1&
    IP_ADAPTER_ADDRESS_TRANSIENT = &H2&
End Enum

' IP_ADAPTER_ADDRESSES_LH.Flags
Public Enum IP_ADAPTER_ADDRESSES_LH_FLAGS
    IP_ADAPTER_DDNS_ENABLED = &H1&
    IP_ADAPTER_REGISTER_ADAPTER_SUFFIX = &H2&
    IP_ADAPTER_DHCP_ENABLED = &H4&
    IP_ADAPTER_RECEIVE_ONLY = &H8&
    IP_ADAPTER_NO_MULTICAST = &H10&
    IP_ADAPTER_IPV6_OTHER_STATEFUL_CONFIG = &H20&
    IP_ADAPTER_NETBIOS_OVER_TCPIP_ENABLED = &H40&
    IP_ADAPTER_IPV4_ENABLED = &H80&
    IP_ADAPTER_IPV6_ENABLED = &H100&
    IP_ADAPTER_IPV6_MANAGE_ADDRESS_CONFIG = &H200&
End Enum

' IP_ADAPTER_ADDRESSES_LH.IfType
Public Enum IP_ADAPTER_ADDRESSES_LH_IFTYPE
    IF_TYPE_OTHER = &H1&
    IF_TYPE_REGULAR_1822 = &H2&
    IF_TYPE_HDH_1822 = &H3&
    IF_TYPE_DDN_X25 = &H4&
    IF_TYPE_RFC877_X25 = &H5&
    IF_TYPE_ETHERNET_CSMACD = &H6&
    IF_TYPE_IS088023_CSMACD = &H7&
    IF_TYPE_ISO88024_TOKENBUS = &H8&
    IF_TYPE_ISO88025_TOKENRING = &H9&
    IF_TYPE_ISO88026_MAN = &HA&
    IF_TYPE_STARLAN = &HB&
    IF_TYPE_PROTEON_10MBIT = &HC&
    IF_TYPE_PROTEON_80MBIT = &HD&
    IF_TYPE_HYPERCHANNEL = &HE&
    IF_TYPE_FDDI = &HF&
    IF_TYPE_LAP_B = &H10&
    IF_TYPE_SDLC = &H11&
    IF_TYPE_DS1 = &H12&
    IF_TYPE_E1 = &H13&
    IF_TYPE_BASIC_ISDN = &H14&
    IF_TYPE_PRIMARY_ISDN = &H15&
    IF_TYPE_PROP_POINT2POINT_SERIAL = &H16&
    IF_TYPE_PPP = &H17&
    IF_TYPE_SOFTWARE_LOOPBACK = &H18&
    IF_TYPE_EON = &H19&
    IF_TYPE_ETHERNET_3MBIT = &H1A&
    IF_TYPE_NSIP = &H1B&
    IF_TYPE_SLIP = &H1C&
    IF_TYPE_ULTRA = &H1D&
    IF_TYPE_DS3 = &H1E&
    IF_TYPE_SIP = &H1F&
    IF_TYPE_FRAMERELAY = &H20&
    IF_TYPE_RS232 = &H21&
    IF_TYPE_PARA = &H22&
    IF_TYPE_ARCNET = &H23&
    IF_TYPE_ARCNET_PLUS = &H24&
    IF_TYPE_ATM = &H25&
    IF_TYPE_MIO_X25 = &H26&
    IF_TYPE_SONET = &H27&
    IF_TYPE_X25_PLE = &H28&
    IF_TYPE_ISO88022_LLC = &H29&
    IF_TYPE_LOCALTALK = &H2A&
    IF_TYPE_SMDS_DXI = &H2B&
    IF_TYPE_FRAMERELAY_SERVICE = &H2C&
    IF_TYPE_V35 = &H2D&
    IF_TYPE_HSSI = &H2E&
    IF_TYPE_HIPPI = &H2F&
    IF_TYPE_MODEM = &H30&
    IF_TYPE_AAL5 = &H31&
    IF_TYPE_SONET_PATH = &H32&
    IF_TYPE_SONET_VT = &H33&
    IF_TYPE_SMDS_ICIP = &H34&
    IF_TYPE_PROP_VIRTUAL = &H35&
    IF_TYPE_PROP_MULTIPLEXOR = &H36&
    IF_TYPE_IEEE80212 = &H37&
    IF_TYPE_FIBRECHANNEL = &H38&
    IF_TYPE_HIPPIINTERFACE = &H39&
    IF_TYPE_FRAMERELAY_INTERCONNECT = &H3A&
    IF_TYPE_AFLANE_8023 = &H3B&
    IF_TYPE_AFLANE_8025 = &H3C&
    IF_TYPE_CCTEMUL = &H3D&
    IF_TYPE_FASTETHER = &H3E&
    IF_TYPE_ISDN = &H3F&
    IF_TYPE_V11 = &H40&
    IF_TYPE_V36 = &H41&
    IF_TYPE_G703_64K = &H42&
    IF_TYPE_G703_2MB = &H43&
    IF_TYPE_QLLC = &H44&
    IF_TYPE_FASTETHER_FX = &H45&
    IF_TYPE_CHANNEL = &H46&
    IF_TYPE_IEEE80211 = &H47&
    IF_TYPE_IBM370PARCHAN = &H48&
    IF_TYPE_ESCON = &H49&
    IF_TYPE_DLSW = &H4A&
    IF_TYPE_ISDN_S = &H4B&
    IF_TYPE_ISDN_U = &H4C&
    IF_TYPE_LAP_D = &H4D&
    IF_TYPE_IPSWITCH = &H4E&
    IF_TYPE_RSRB = &H4F&
    IF_TYPE_ATM_LOGICAL = &H50&
    IF_TYPE_DS0 = &H51&
    IF_TYPE_DS0_BUNDLE = &H52&
    IF_TYPE_BSC = &H53&
    IF_TYPE_ASYNC = &H54&
    IF_TYPE_CNR = &H55&
    IF_TYPE_ISO88025R_DTR = &H56&
    IF_TYPE_EPLRS = &H57&
    IF_TYPE_ARAP = &H58&
    IF_TYPE_PROP_CNLS = &H59&
    IF_TYPE_HOSTPAD = &H5A&
    IF_TYPE_TERMPAD = &H5B&
    IF_TYPE_FRAMERELAY_MPI = &H5C&
    IF_TYPE_X213 = &H5D&
    IF_TYPE_ADSL = &H5E&
    IF_TYPE_RADSL = &H5F&
    IF_TYPE_SDSL = &H60&
    IF_TYPE_VDSL = &H61&
    IF_TYPE_ISO88025_CRFPRINT = &H62&
    IF_TYPE_MYRINET = &H63&
    IF_TYPE_VOICE_EM = &H64&
    IF_TYPE_VOICE_FXO = &H65&
    IF_TYPE_VOICE_FXS = &H66&
    IF_TYPE_VOICE_ENCAP = &H67&
    IF_TYPE_VOICE_OVERIP = &H68&
    IF_TYPE_ATM_DXI = &H69&
    IF_TYPE_ATM_FUNI = &H6A&
    IF_TYPE_ATM_IMA = &H6B&
    IF_TYPE_PPPMULTILINKBUNDLE = &H6C&
    IF_TYPE_IPOVER_CDLC = &H6D&
    IF_TYPE_IPOVER_CLAW = &H6E&
    IF_TYPE_STACKTOSTACK = &H6F&
    IF_TYPE_VIRTUALIPADDRESS = &H70&
    IF_TYPE_MPC = &H71&
    IF_TYPE_IPOVER_ATM = &H72&
    IF_TYPE_ISO88025_FIBER = &H73&
    IF_TYPE_TDLC = &H74&
    IF_TYPE_GIGABITETHERNET = &H75&
    IF_TYPE_HDLC = &H76&
    IF_TYPE_LAP_F = &H77&
    IF_TYPE_V37 = &H78&
    IF_TYPE_X25_MLP = &H79&
    IF_TYPE_X25_HUNTGROUP = &H7A&
    IF_TYPE_TRANSPHDLC = &H7B&
    IF_TYPE_INTERLEAVE = &H7C&
    IF_TYPE_FAST = &H7D&
    IF_TYPE_IP = &H7E&
    IF_TYPE_DOCSCABLE_MACLAYER = &H7F&
    IF_TYPE_DOCSCABLE_DOWNSTREAM = &H80&
    IF_TYPE_DOCSCABLE_UPSTREAM = &H81&
    IF_TYPE_A12MPPSWITCH = &H82&
    IF_TYPE_TUNNEL = &H83&
    IF_TYPE_COFFEE = &H84&
    IF_TYPE_CES = &H85&
    IF_TYPE_ATM_SUBINTERFACE = &H86&
    IF_TYPE_L2_VLAN = &H87&
    IF_TYPE_L3_IPVLAN = &H88&
    IF_TYPE_L3_IPXVLAN = &H89&
    IF_TYPE_DIGITALPOWERLINE = &H8A&
    IF_TYPE_MEDIAMAILOVERIP = &H8B&
    IF_TYPE_DTM = &H8C&
    IF_TYPE_DCN = &H8D&
    IF_TYPE_IPFORWARD = &H8E&
    IF_TYPE_MSDSL = &H8F&
    IF_TYPE_IEEE1394 = &H90&
    IF_TYPE_IF_GSN = &H91&
    IF_TYPE_DVBRCC_MACLAYER = &H92&
    IF_TYPE_DVBRCC_DOWNSTREAM = &H93&
    IF_TYPE_DVBRCC_UPSTREAM = &H94&
    IF_TYPE_ATM_VIRTUAL = &H95&
    IF_TYPE_MPLS_TUNNEL = &H96&
    IF_TYPE_SRP = &H97&
    IF_TYPE_VOICEOVERATM = &H98&
    IF_TYPE_VOICEOVERFRAMERELAY = &H99&
    IF_TYPE_IDSL = &H9A&
    IF_TYPE_COMPOSITELINK = &H9B&
    IF_TYPE_SS7_SIGLINK = &H9C&
    IF_TYPE_PROP_WIRELESS_P2P = &H9D&
    IF_TYPE_FR_FORWARD = &H9E&
    IF_TYPE_RFC1483 = &H9F&
    IF_TYPE_USB = &HA0&
    IF_TYPE_IEEE8023AD_LAG = &HA1&
    IF_TYPE_BGP_POLICY_ACCOUNTING = &HA2&
    IF_TYPE_FRF16_MFR_BUNDLE = &HA3&
    IF_TYPE_H323_GATEKEEPER = &HA4&
    IF_TYPE_H323_PROXY = &HA5&
    IF_TYPE_MPLS = &HA6&
    IF_TYPE_MF_SIGLINK = &HA7&
    IF_TYPE_HDSL2 = &HA8&
    IF_TYPE_SHDSL = &HA9&
    IF_TYPE_DS1_FDL = &HAA&
    IF_TYPE_POS = &HAB&
    IF_TYPE_DVB_ASI_IN = &HAC&
    IF_TYPE_DVB_ASI_OUT = &HAD&
    IF_TYPE_PLC = &HAE&
    IF_TYPE_NFAS = &HAF&
    IF_TYPE_TR008 = &HB0&
    IF_TYPE_GR303_RDT = &HB1&
    IF_TYPE_GR303_IDT = &HB2&
    IF_TYPE_ISUP = &HB3&
    IF_TYPE_PROP_DOCS_WIRELESS_MACLAYER = &HB4&
    IF_TYPE_PROP_DOCS_WIRELESS_DOWNSTREAM = &HB5&
    IF_TYPE_PROP_DOCS_WIRELESS_UPSTREAM = &HB6&
    IF_TYPE_HIPERLAN2 = &HB7&
    IF_TYPE_PROP_BWA_P2MP = &HB8&
    IF_TYPE_SONET_OVERHEAD_CHANNEL = &HB9&
    IF_TYPE_DIGITAL_WRAPPER_OVERHEAD_CHANNEL = &HBA&
    IF_TYPE_AAL2 = &HBB&
    IF_TYPE_RADIO_MAC = &HBC&
    IF_TYPE_ATM_RADIO = &HBD&
    IF_TYPE_IMT = &HBE&
    IF_TYPE_MVL = &HBF&
    IF_TYPE_REACH_DSL = &HC0&
    IF_TYPE_FR_DLCI_ENDPT = &HC1&
    IF_TYPE_ATM_VCI_ENDPT = &HC2&
    IF_TYPE_OPTICAL_CHANNEL = &HC3&
    IF_TYPE_OPTICAL_TRANSPORT = &HC4&
    IF_TYPE_IEEE80216_WMAN = &HED&
    IF_TYPE_WWANPP = &HF3&
    IF_TYPE_WWANPP2 = &HF4&
    IF_TYPE_IEEE802154 = &H103&
    IF_TYPE_XBOX_WIRELESS = &H119&
End Enum

' IP_ADAPTER_ADDRESSES_LH.OperStatus
Public Enum IF_OPER_STATUS
    IfOperStatusUp = &H1&
    IfOperStatusDown = &H2&
    IfOperStatusTesting = &H3&
    IfOperStatusUnknown = &H4&
    IfOperStatusDormant = &H5&
    IfOperStatusNotPresent = &H6&
    IfOperStatusLowerLayerDown = &H7&
End Enum

' IP_ADAPTER_ADDRESSES_LH.ZoneIndices
Public Enum SCOPE_LEVEL
    ScopeLevelInterface = &H1&
    ScopeLevelLink = &H2&
    ScopeLevelSubnet = &H3&
    ScopeLevelAdmin = &H4&
    ScopeLevelSite = &H5&
    ScopeLevelOrganization = &H8&
    ScopeLevelGlobal = &HE&
    ScopeLevelCount = &H10&
End Enum

' GetAdaptersAddresses Family
' InetNtopW Family
' SOCKADDR.sa_family
Public Enum AF_FAMILY
    AF_UNSPEC = &H0&
    AF_INET = &H2&
    AF_INET6 = &H17&
End Enum

' GetAdaptersAddresses Flags
Public Enum GAA_FLAGS
    GAA_FLAG_DEFAULT = &H0&
    GAA_FLAG_SKIP_UNICAST = &H1&
    GAA_FLAG_SKIP_ANYCAST = &H2&
    GAA_FLAG_SKIP_MULTICAST = &H4&
    GAA_FLAG_SKIP_DNS_SERVER = &H8&
    GAA_FLAG_INCLUDE_PREFIX = &H10&
    GAA_FLAG_SKIP_FRIENDLY_NAME = &H20&
    GAA_FLAG_INCLUDE_WINS_INFO = &H40&
    GAA_FLAG_INCLUDE_GATEWAYS = &H80&
    GAA_FLAG_INCLUDE_ALL_INTERFACES = &H100&
    GAA_FLAG_INCLUDE_ALL_COMPARTMENTS = &H200&
    GAA_FLAG_INCLUDE_TUNNEL_BINDINGORDER = &H400&
End Enum

' IP_ADAPTER_UNICAST_ADDRESS_LH.PrefixOrigin
Public Enum NL_PREFIX_ORIGIN
    IpPrefixOriginOther = &H0&
    IpPrefixOriginManual = &H1&
    IpPrefixOriginWellKnown = &H2&
    IpPrefixOriginDhcp = &H3&
    IpPrefixOriginRouterAdvertisement = &H4&
    IpPrefixOriginUnchanged = &H10&
End Enum

' IP_ADAPTER_UNICAST_ADDRESS_LH.SuffixOrigin
Public Enum NL_SUFFIX_ORIGIN
    IpSuffixOriginOther = &H0&
    IpSuffixOriginManual = &H1&
    IpSuffixOriginWellKnown = &H2&
    IpSuffixOriginDhcp = &H3&
    IpSuffixOriginLinkLayerAddress = &H4&
    IpSuffixOriginRandom = &H5&
    IpSuffixOriginUnchanged = &H10&
End Enum

' IP_ADAPTER_UNICAST_ADDRESS_LH.DadState
Public Enum NL_DAD_STATE
    IpDadStateInvalid = &H0&
    IpDadStateTentative = &H1&
    IpDadStateDuplicate = &H2&
    IpDadStateDeprecated = &H3&
    IpDadStatePreferred = &H4&
End Enum

' IP_ADAPTER_ADDRESSES_LH.CompartmentID
Public Enum NET_IF_COMPARTMENT_ID
    NET_IF_COMPARTMENT_ID_UNSPECIFIED = &H0&
    NET_IF_COMPARTMENT_ID_PRIMARY = &H1&
End Enum

' IP_ADAPTER_ADDRESSES_LH.ConnectionType
Public Enum NET_IF_CONNECTION_TYPE
    NET_IF_CONNECTION_DEDICATED = &H1&
    NET_IF_CONNECTION_PASSIVE = &H2&
    NET_IF_CONNECTION_DEMAND = &H3&
    NET_IF_CONNECTION_MAXIMUM = &H4&
End Enum

' IP_ADAPTER_ADDRESSES_LH.TunnelType
Public Enum TUNNEL_TYPE
    TUNNEL_TYPE_NONE = &H0&
    TUNNEL_TYPE_OTHER = &H1&
    TUNNEL_TYPE_DIRECT = &H2&
    TUNNEL_TYPE_6TO4 = &HB&
    TUNNEL_TYPE_ISATAP = &HD&
    TUNNEL_TYPE_TEREDO = &HE&
    TUNNEL_TYPE_IPHTTPS = &HF&
End Enum

' ----==== Types ====----
' SOCKADDR_IN.sin_addr
Public Type in_addr
    s_b(3) As Byte
End Type

' SOCKADDR_IN6.sin6_addr
Public Type IN6_ADDR
    s_b(15) As Byte
End Type

Public Type SOCKADDR
    sa_family As Integer
    sa_data(13) As Byte
End Type

Public Type SOCKADDR_IN
    sin_family As Integer
    sin_port As Integer
    sin_addr As in_addr
    sin_zero(7) As Byte
End Type

Public Type SOCKADDR_IN6
    sin6_family As Integer
    sin6_port As Integer
    sin6_flowinfo As Long
    sin6_addr As IN6_ADDR
    sin6_scope_id As Long
End Type

Public Type SOCKET_ADDRESS
    lpSockaddr As Long ' -> SOCKADDR
    iSockaddrLength As Long
End Type

Public Type IP_ADAPTER_UNICAST_ADDRESS_LH
    Length As Long
    Flags As IP_ADAPTER_XXX_ADDRESS_XX_FLAGS
    Next As Long
    Address As SOCKET_ADDRESS
    PrefixOrigin As NL_PREFIX_ORIGIN
    SuffixOrigin As NL_SUFFIX_ORIGIN
    DadState As NL_DAD_STATE
    ValidLifetime As Long
    PreferredLifetime As Long
    LeaseLifetime As Long
    OnLinkPrefixLength As Long
End Type

Public Type IP_ADAPTER_DNS_SERVER_ADDRESS_XP
    Length As Long
    Reserved As Long
    Next As Long
    Address As SOCKET_ADDRESS
End Type

Public Type IP_ADAPTER_MULTICAST_ADDRESS_XP
    Length As Long
    Flags As IP_ADAPTER_XXX_ADDRESS_XX_FLAGS
    Next As Long
    Address As SOCKET_ADDRESS
End Type

Public Type IP_ADAPTER_ANYCAST_ADDRESS_XP
    Length As Long
    Flags As IP_ADAPTER_XXX_ADDRESS_XX_FLAGS
    Next As Long
    Address As SOCKET_ADDRESS
End Type

Public Type IP_ADAPTER_PREFIX_XP
    Length As Long
    Flags As Long
    Next As Long
    Address As SOCKET_ADDRESS
    PrefixLength As Long
End Type

Public Type IP_ADAPTER_DNS_SUFFIX
    Next As Long
    Str(MAX_DNS_SUFFIX_STRING_LENGTH - 1) As Byte
End Type

Public Type IP_ADAPTER_WINS_SERVER_ADDRESS_LH
    Length As Long
    Reserved As Long
    Next As Long
    Address As SOCKET_ADDRESS
End Type

Public Type IP_ADAPTER_GATEWAY_ADDRESS_LH
    Length As Long
    Reserved As Long
    Next As Long
    Address As SOCKET_ADDRESS
End Type

Public Type IF_LUID
    Value As Long
    Padding As Long
End Type

Public Type NET_IF_NETWORK_GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Public Type IP_ADAPTER_ADDRESSES_LH
    Length As Long
    IfIndex As Long
    Next As Long
    AdapterName As Long
    FirstUnicastAddress As Long ' -> IP_ADAPTER_UNICAST_ADDRESS_LH
    FirstAnycastAddress As Long ' -> IP_ADAPTER_ANYCAST_ADDRESS_XP
    FirstMulticastAddress As Long ' -> IP_ADAPTER_MULTICAST_ADDRESS_XP
    FirstDnsServerAddress As Long ' -> IP_ADAPTER_DNS_SERVER_ADDRESS_XP
    DnsSuffix As Long
    Description As Long
    FriendlyName As Long
    PhysicalAddress(MAX_ADAPTER_ADDRESS_LENGTH - 1) As Byte
    PhysicalAddressLength As Long
    Flags As IP_ADAPTER_ADDRESSES_LH_FLAGS
    Mtu As Long
    IfType As IP_ADAPTER_ADDRESSES_LH_IFTYPE
    OperStatus As IF_OPER_STATUS
    Ipv6IfIndex As Long
    ZoneIndices(15) As SCOPE_LEVEL
    FirstPrefix As Long ' -> IP_ADAPTER_PREFIX_XP
    TransmitLinkSpeed As Currency
    ReceiveLinkSpeed As Currency
    FirstWinsServerAddress As Long ' -> IP_ADAPTER_WINS_SERVER_ADDRESS_LH
    FirstGatewayAddress As Long ' -> IP_ADAPTER_GATEWAY_ADDRESS_LH
    Ipv4Metric As Long
    Ipv6Metric As Long
    Luid As IF_LUID
    Dhcpv4Server As SOCKET_ADDRESS
    CompartmentID As NET_IF_COMPARTMENT_ID
    NetworkGuid As NET_IF_NETWORK_GUID
    ConnectionType As NET_IF_CONNECTION_TYPE
    TunnelType As TUNNEL_TYPE
    Dhcpv6Server As SOCKET_ADDRESS
    Dhcpv6ClientDuid(MAX_DHCPV6_DUID_LENGTH - 1) As Byte
    Dhcpv6ClientDuidLength As Long
    Dhcpv6Iaid As Long
    FirstDnsSuffix As Long ' -> IP_ADAPTER_DNS_SUFFIX
End Type

' ----==== Iphlpapi.dll ====----
Public Declare Function GetAdaptersAddresses Lib "Iphlpapi.dll" ( _
                        ByVal Family As AF_FAMILY, _
                        ByVal Flags As GAA_FLAGS, _
                        ByVal Reserved As Long, _
                        ByVal AdapterAddresses As Long, _
                        ByRef SizePointer As Long) As Long
                        
Public Declare Function ConvertLengthToIpv4Mask Lib "Iphlpapi.dll" ( _
                        ByVal MaskLength As Long, _
                        ByRef Mask As Long) As Long
                        
Public Declare Function ConvertInterfaceLuidToNameW Lib "Iphlpapi.dll" ( _
                        ByVal InterfaceLuid As Long, _
                        ByVal InterfaceName As Long, _
                        ByVal Length As Long) As Long
                        
' ----==== Ws2_32.dll ====----
Public Declare Function InetNtopW Lib "Ws2_32.dll" ( _
                        ByVal Family As AF_FAMILY, _
                        ByVal pAddr As Long, _
                        ByVal pStringBuf As Long, _
                        ByVal StringBufSize As Long) As Long
                        
' ----==== Kernel32.dll ====----
Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef Destination As Any, _
                   ByRef Source As Any, _
                   ByVal Length As Long)
                   
Public Declare Function lstrlenW Lib "kernel32" ( _
                        ByVal lpString As Long) As Long
                        
' ----==== User32.dll ====----
Public Declare Function SendMessageW Lib "User32.dll" ( _
                        ByVal hwnd As Long, _
                        ByVal wMsg As Long, _
                        ByVal wParam As Long, _
                        ByVal lParam As Any) As Long
                        
' ----==== Ole32.dll ====----
Public Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                   ByVal hMem As Long)
                   
Public Declare Function StringFromGUID Lib "Ole32.dll" _
                        Alias "StringFromCLSID" ( _
                        ByVal pclsid As Long, _
                        ByRef lpszProgID As Long) As Long
                        
Public Function SetText(ByVal TB As TextBox, ByVal strText As String) As Long

    SetText = SendMessageW(TB.hwnd, WM_SETTEXT, 0&, StrPtr(strText))
    
End Function

Public Function CutNull(ByVal strValue As String) As String

    Dim lngPos As Long
    Dim strRet As String

    lngPos = InStr(1, strValue, vbNullChar)

    If lngPos > 0 Then

        strRet = Mid$(strValue, 1&, lngPos - 1&)

    Else

        strRet = strValue

    End If

    CutNull = strRet

End Function
                        
Public Function Ptr2String(ByVal pStrPointer As Long) As String

    Dim lngLen As Long
    Dim strRet As String
    Dim bytBuff() As Byte
    
    If pStrPointer <> 0& Then
    
        lngLen = lstrlenW(pStrPointer) * 2&
        
        If lngLen > 0& Then
        
            ReDim bytBuff(lngLen - 1&)
            
            Call CopyMemory(bytBuff(0), ByVal pStrPointer, lngLen)
            
            Call CoTaskMemFree(pStrPointer)
            
            strRet = CStr(bytBuff)
            
        End If
        
    End If
    
    Ptr2String = strRet
    
End Function

Public Function Guid2String(ByRef tGUID As NET_IF_NETWORK_GUID) As String

    Dim pGuid As Long
    Dim strRet As String
    
    If StringFromGUID(VarPtr(tGUID), pGuid) = S_OK Then
    
        strRet = Ptr2String(pGuid)
        
    End If
    
    Guid2String = strRet
    
End Function

Public Function Long2ByteArray(ByVal lngValue As Long) As Byte()

    Dim bytArray(0 To 3) As Byte
    
    Call CopyMemory(bytArray(0), ByVal VarPtr(lngValue), 4&)
    
    Long2ByteArray = bytArray

End Function

Public Function Luid2String(ByRef tLUID As IF_LUID) As String

    Dim strRet As String
    Dim bytLUID(NDIS_IF_MAX_STRING_SIZE - 1) As Byte
    
    If ConvertInterfaceLuidToNameW(VarPtr(tLUID.Value), VarPtr(bytLUID(0)), _
        NDIS_IF_MAX_STRING_SIZE) = NETIO_ERROR_SUCCESS Then
        
        strRet = CutNull(CStr(bytLUID))
        
    End If
    
    Luid2String = strRet
    
End Function

Public Function IfType2String(ByVal eIfType As IP_ADAPTER_ADDRESSES_LH_IFTYPE) As String
    
    Dim strRet As String
    
    Select Case eIfType
    
    Case IF_TYPE_OTHER
        strRet = "IF_TYPE_OTHER"
        
    Case IF_TYPE_ETHERNET_CSMACD
        strRet = "IF_TYPE_ETHERNET_CSMACD"
        
    Case IF_TYPE_ISO88025_TOKENRING
        strRet = "IF_TYPE_ISO88025_TOKENRING"
        
    Case IF_TYPE_PPP
        strRet = "IF_TYPE_PPP"
        
    Case IF_TYPE_SOFTWARE_LOOPBACK
        strRet = "IF_TYPE_SOFTWARE_LOOPBACK"
        
    Case IF_TYPE_ATM
        strRet = "IF_TYPE_ATM"
        
    Case IF_TYPE_IEEE80211
        strRet = "IF_TYPE_IEEE80211"
        
    Case IF_TYPE_TUNNEL
        strRet = "IF_TYPE_TUNNEL"
        
    Case IF_TYPE_IEEE1394
        strRet = "IF_TYPE_IEEE1394"
        
    Case Else
        strRet = CStr(eIfType) & " (see Enum IP_ADAPTER_ADDRESSES_LH_IFTYPE)"
        
    End Select
    
    IfType2String = strRet
    
End Function

Public Function DadState2String(ByVal eDadState As NL_DAD_STATE) As String

    Dim strRet As String
    
    Select Case eDadState
    
    Case IpDadStateInvalid
        strRet = "IpDadStateInvalid"
        
    Case IpDadStateTentative
        strRet = "IpDadStateTentative"
        
    Case IpDadStateDuplicate
        strRet = "IpDadStateDuplicate"
        
    Case IpDadStateDeprecated
        strRet = "IpDadStateDeprecated"
        
    Case IpDadStatePreferred
        strRet = "IpDadStatePreferred"
        
    End Select
    
    DadState2String = strRet
    
End Function

Public Function SuffixOrigin2String(ByVal eSuffixOrigin As NL_SUFFIX_ORIGIN) As String

    Dim strRet As String
    
    Select Case eSuffixOrigin
    
    Case IpSuffixOriginOther
        strRet = "IpSuffixOriginOther"
        
    Case IpSuffixOriginManual
        strRet = "IpSuffixOriginManual"
        
    Case IpSuffixOriginWellKnown
        strRet = "IpSuffixOriginWellKnown"
        
    Case IpSuffixOriginDhcp
        strRet = "IpSuffixOriginDhcp"
        
    Case IpSuffixOriginLinkLayerAddress
        strRet = "IpSuffixOriginLinkLayerAddress"
        
    Case IpSuffixOriginRandom
        strRet = "IpSuffixOriginRandom"
        
    Case IpSuffixOriginUnchanged
        strRet = "IpSuffixOriginUnchanged"
        
    End Select
    
    SuffixOrigin2String = strRet
    
End Function

Public Function PrefixOrigin2String(ByVal ePrefixOrigin As NL_PREFIX_ORIGIN) As String

    Dim strRet As String
    
    Select Case ePrefixOrigin
    
    Case IpPrefixOriginOther
        strRet = "IpPrefixOriginOther"
        
    Case IpPrefixOriginManual
        strRet = "IpPrefixOriginManual"
        
    Case IpPrefixOriginWellKnown
        strRet = "IpPrefixOriginWellKnown"
        
    Case IpPrefixOriginDhcp
        strRet = "IpPrefixOriginDhcp"
        
    Case IpPrefixOriginRouterAdvertisement
        strRet = "IpPrefixOriginRouterAdvertisement"
        
    Case IpPrefixOriginUnchanged
        strRet = "IpPrefixOriginUnchanged"
        
    End Select
    
    PrefixOrigin2String = strRet
    
End Function

Public Function ScopeLevel2String(ByVal eScopeLevel As SCOPE_LEVEL) As String

    Dim strRet As String
    
    Select Case eScopeLevel
    
    Case ScopeLevelInterface
        strRet = "ScopeLevelInterface"
        
    Case ScopeLevelLink
        strRet = "ScopeLevelLink"
        
    Case ScopeLevelSubnet
        strRet = "ScopeLevelSubnet"
        
    Case ScopeLevelAdmin
        strRet = "ScopeLevelAdmin"
        
    Case ScopeLevelSite
        strRet = "ScopeLevelSite"
        
    Case ScopeLevelOrganization
        strRet = "ScopeLevelOrganization"
        
    Case ScopeLevelGlobal
        strRet = "ScopeLevelGlobal"
        
    Case ScopeLevelCount
        strRet = "ScopeLevelCount"
        
    End Select
    
    ScopeLevel2String = strRet
    
End Function

Public Function TunnelType2String(ByVal eTunnelType As TUNNEL_TYPE) As String

    Dim strRet As String
    
    Select Case eTunnelType
    
    Case TUNNEL_TYPE_NONE
        strRet = "TUNNEL_TYPE_NONE"
        
    Case TUNNEL_TYPE_OTHER
        strRet = "TUNNEL_TYPE_OTHER"
        
    Case TUNNEL_TYPE_DIRECT
        strRet = "TUNNEL_TYPE_DIRECT"
        
    Case TUNNEL_TYPE_6TO4
        strRet = "TUNNEL_TYPE_6TO4"
        
    Case TUNNEL_TYPE_ISATAP
        strRet = "TUNNEL_TYPE_ISATAP"
        
    Case TUNNEL_TYPE_TEREDO
        strRet = "TUNNEL_TYPE_TEREDO"
        
    Case TUNNEL_TYPE_IPHTTPS
        strRet = "TUNNEL_TYPE_IPHTTPS"
        
    End Select
    
    TunnelType2String = strRet
    
End Function

Public Function OperStatus2String(ByVal eOperStatus As IF_OPER_STATUS) As String

    Dim strRet As String
    
    Select Case eOperStatus
    
    Case IfOperStatusUp
        strRet = "IfOperStatusUp"
        
    Case IfOperStatusDown
        strRet = "IfOperStatusDown"
        
    Case IfOperStatusTesting
        strRet = "IfOperStatusTesting"
        
    Case IfOperStatusUnknown
        strRet = "IfOperStatusUnknown"
        
    Case IfOperStatusDormant
        strRet = "IfOperStatusDormant"
        
    Case IfOperStatusNotPresent
        strRet = "IfOperStatusNotPresent"
        
    Case IfOperStatusLowerLayerDown
        strRet = "IfOperStatusLowerLayerDown"
        
    End Select
    
    OperStatus2String = strRet
    
End Function

Public Function CompartmentID2String(ByVal eCompartmentID As NET_IF_COMPARTMENT_ID) As String
    
    Dim strRet As String
    
    Select Case eCompartmentID
    
    Case NET_IF_COMPARTMENT_ID_UNSPECIFIED
        strRet = "NET_IF_COMPARTMENT_ID_UNSPECIFIED"
        
    Case NET_IF_COMPARTMENT_ID_PRIMARY
        strRet = "NET_IF_COMPARTMENT_ID_PRIMARY"
        
    End Select
    
    CompartmentID2String = strRet
    
End Function

Public Function ConnectionType2String(ByVal eConnectionType As NET_IF_CONNECTION_TYPE) As String
    
    Dim strRet As String
    
    Select Case eConnectionType
    
    Case NET_IF_CONNECTION_DEDICATED
        strRet = "NET_IF_CONNECTION_DEDICATED"
        
    Case NET_IF_CONNECTION_PASSIVE
        strRet = "NET_IF_CONNECTION_PASSIVE"
        
    Case NET_IF_CONNECTION_DEMAND
        strRet = "NET_IF_CONNECTION_DEMAND"
        
    Case NET_IF_CONNECTION_MAXIMUM
        strRet = "NET_IF_CONNECTION_MAXIMUM"
        
    End Select
    
    ConnectionType2String = strRet
    
End Function

Public Function AdapterAddressFlags2String(ByVal eFlags As IP_ADAPTER_XXX_ADDRESS_XX_FLAGS) As String
    
    Dim strRet As String
    
    Select Case eFlags
    
    Case IP_ADAPTER_ADDRESS_DNS_ELIGIBLE
        strRet = "IP_ADAPTER_ADDRESS_DNS_ELIGIBLE"
        
    Case IP_ADAPTER_ADDRESS_TRANSIENT
        strRet = "IP_ADAPTER_ADDRESS_TRANSIENT"
        
    End Select
    
    AdapterAddressFlags2String = strRet
    
End Function

Public Function AdapterAddressesFlags2String(ByVal eFlags As IP_ADAPTER_ADDRESSES_LH_FLAGS) As String
    
    Dim strRet As String
    
    If eFlags <> 0& Then
    
        If CBool(eFlags And IP_ADAPTER_DDNS_ENABLED) = True Then strRet = strRet & "IP_ADAPTER_DDNS_ENABLED" & " | "
        
        If CBool(eFlags And IP_ADAPTER_REGISTER_ADAPTER_SUFFIX) = True Then strRet = strRet & "IP_ADAPTER_REGISTER_ADAPTER_SUFFIX" & " | "
        
        If CBool(eFlags And IP_ADAPTER_DHCP_ENABLED) = True Then strRet = strRet & "IP_ADAPTER_DHCP_ENABLED" & " | "
        
        If CBool(eFlags And IP_ADAPTER_RECEIVE_ONLY) = True Then strRet = strRet & "IP_ADAPTER_RECEIVE_ONLY" & " | "
        
        If CBool(eFlags And IP_ADAPTER_NO_MULTICAST) = True Then strRet = strRet & "IP_ADAPTER_NO_MULTICAST" & " | "
        
        If CBool(eFlags And IP_ADAPTER_IPV6_OTHER_STATEFUL_CONFIG) = True Then strRet = strRet & "IP_ADAPTER_IPV6_OTHER_STATEFUL_CONFIG" & " | "
        
        If CBool(eFlags And IP_ADAPTER_NETBIOS_OVER_TCPIP_ENABLED) = True Then strRet = strRet & "IP_ADAPTER_NETBIOS_OVER_TCPIP_ENABLED" & " | "
        
        If CBool(eFlags And IP_ADAPTER_IPV4_ENABLED) = True Then strRet = strRet & "IP_ADAPTER_IPV4_ENABLED" & " | "
        
        If CBool(eFlags And IP_ADAPTER_IPV6_ENABLED) = True Then strRet = strRet & "IP_ADAPTER_IPV6_ENABLED" & " | "
        
        If CBool(eFlags And IP_ADAPTER_IPV6_MANAGE_ADDRESS_CONFIG) = True Then strRet = strRet & "IP_ADAPTER_IPV6_MANAGE_ADDRESS_CONFIG" & " | "
    
        strRet = Mid$(strRet, 1&, Len(strRet) - Len(" | "))
        
    End If
    
    AdapterAddressesFlags2String = strRet
    
End Function
